<template>
    <div>

      <Loader v-if="loading" />

      <div v-else class="app-main-layout">

        <Header @click="isOpened = !isOpened" />

        <Navigation v-model="isOpened" />

        <main class="app-content" :class="{full: !isOpened}">
          <div class="app-page">
            <router-view />
          </div>
        </main>

        <div class="fixed-action-btn">
          <router-link class="btn-floating btn-large blue" to="/record">
            <i class="large material-icons">add</i>
          </router-link>
        </div>
      </div>
    </div>
</template>

<script>

import Header from "@/components/layout/Header";
import Navigation from "@/components/layout/Navigation";
import messages from "@/utils/messages";

export default {
  name: "AppLayout",
  data: () => ({
    isOpened: true,
    loading: true
  }),
  components: {
    Header, Navigation
  },
  computed: {
    errorMessage() {
      return this.$store.getters.getErrorMessage;
    }
  },
  watch: {
    errorMessage(error) {
      const code = error.code || error.message;
      this.$message(messages[code] || messages['something_went_wrong']);
    }
  },
  async mounted() {
    if (Object.keys(this.$store.getters.getUserInfo).length === 0) {
      await this.$store.dispatch('getUserInfo');
    }

    this.loading = false;
  }
}
</script>

<style scoped>

</style>